﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="DigizuiteAdminPlugin.aspx.cs" Inherits="Digizuite.Episerver.Templates.Plugins.DigizuiteAdminPlugin" %>
<%@ Register TagPrefix="EPiServerUI" Namespace="EPiServer.UI.WebControls" Assembly="EPiServer.UI, Version=11.4.4.0, Culture=neutral, PublicKeyToken=8fe83dea738b45b7" %>
<%@ Import Namespace="EPiServer.Framework.Web.Resources" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>Digizuite DAM Administration</title>
    <script type="text/javascript" src="<%= EPiServer.UriSupport.ResolveUrlFromUtilBySettings("javascript/episerverscriptmanager.js") %>"></script>
    <script type="text/javascript" src="<%= EPiServer.UriSupport.ResolveUrlFromUIBySettings("javascript/system.js") %>"></script>
    <script type="text/javascript" src="<%= EPiServer.UriSupport.ResolveUrlFromUIBySettings("javascript/dialog.js") %>"></script>
    <script type="text/javascript" src="<%= EPiServer.UriSupport.ResolveUrlFromUIBySettings("javascript/system.aspx") %>"></script>

    <%=Page.ClientResources("Dojo", new[] { ClientResourceType.Style }) %>
    <%=Page.ClientResources("ShellCore")%>
    <%=Page.ClientResources("ShellCoreLightTheme")%>
    <%=Page.ClientResources("Navigation")%>
    
    <link href="../../../App_Themes/Default/Styles/ToolButton.css" type="text/css" rel="stylesheet" />
    
    <style>
        .hint {
            font-style: italic;
            font-size: 12px;
            color: #8a8a8a;
        }

        .feedback {
            color: red;
            font-style: italic;
            font-size: 12px;
        }

        .dz-loading-icon {
            background: url(<%=EPiServer.Shell.Paths.ToResource("Digizuite", "Static/ajax-loader-grey.gif")%>) center no-repeat;
            margin: 0 10px 0 10px;
            display: inline-block;
            width: 16px;
            height: 16px;
        }

        .animationhidden {
            display: none;
        }
    </style>

    <script type="text/javascript">
        function allowOnlyNumber(evt) {
            var charCode = (evt.which) ? evt.which : event.keyCode;
            console.log(charCode);
            if (charCode > 31 && charCode !== 44 && (charCode < 48 || charCode > 57 ))
                return false;

            return true;
        }

        function showAnimation(evt) {
            document.getElementById('<%= loadingAnimation.ClientID %>').classList.remove("animationhidden");
            document.getElementById('<%= clearAllFeedback.ClientID %>').innerHTML = "";
        }
    </script>
</head>
<body>
<form id="form1" runat="server">
<div class="epi-contentContainer epi-padding">
    <div class="epi-contentArea epi-paddingHorizontal">
        <h1 class="EP-prefix">Digizuite DAM Administration</h1>
        <div class="epi-paddingVertical">
            
            <asp:Panel runat="server">
                The installed version of the Digizuite Episerver connector is <h2><asp:Label runat="server" id="versionNumber"/></h2>
            </asp:Panel>

            <br/><br/>

            <asp:Panel runat="server">
                <h3>Clear Asset</h3>
                <p>With this helper tool you can clear the stored data for an asset. Like the blob storage, the in-memory cache and the database entry. When it is cleared, then next time the asset is requested, the data will be fetched from Digizuite DAM.</p>
                <p>
                    <asp:CheckBox runat="server" ID="checkboxBlob" Text="Blob" Checked="true"/>
                    <asp:CheckBox runat="server" ID="checkboxCache" Text="Cache" Checked="true"/>
                    <asp:CheckBox runat="server" ID="checkboxDatabase" Text="Database" Checked="true"/>
                </p>
                AssetIds: <asp:TextBox runat="server" ID="assetId"  onkeypress="return allowOnlyNumber(event);"/>
                <EPiServerUI:ToolButton ID="clearAssetsBtn" OnClick="ResetAssets" CssClass="epi-cmsButton" CssClassInnerButton="epi-cmsButton-tools epi-cmsButton-Cancel" runat="server" SkinID="File" text="Clear" />
                <asp:Label runat="server" id="clearAssetFeedback" CssClass="feedback"></asp:Label>
                <p class="hint">Clearing multiple assets, separate with comma</p>
            </asp:Panel>
            
            <br/><br/>

            <asp:Panel runat="server">
                <h3>Clear All</h3>
                <p>With this helper tool you can clear all Digizuite stored data. Like the blob storage, the in-memory cache and the database entries. When it is cleared, the next time assets are requested, the data will be fetched from Digizuite DAM.</p>
                <p>
                    <asp:CheckBox runat="server" ID="checkboxBlobAll" Text="Blob" Checked="true"/>
                    <asp:CheckBox runat="server" ID="checkboxCacheAll" Text="Cache" Checked="true"/>
                    <asp:CheckBox runat="server" ID="checkboxDatabaseAll" Text="Database" Checked="true"/>
                </p>
                <EPiServerUI:ToolButton ID="clearAllBtn" OnClick="ResetAll" OnClientClick="showAnimation(event);" CssClass="epi-cmsButton" CssClassInnerButton="epi-cmsButton-tools epi-cmsButton-Cancel" runat="server" SkinID="File" text="Clear All" />
                <asp:Label runat="server" id="clearAllFeedback" CssClass="feedback"></asp:Label>
                <asp:Panel class="dz-loading-icon" ID="loadingAnimation" CssClass="dz-loading-icon animationhidden" runat="server"></asp:Panel>
            </asp:Panel>
        </div>
    </div>
</div>
</form>
</body>
</html>
