﻿define([
    "dojo",
    "dojo/topic",
    "epi/shell/widget/Iframe",
    "dojo/_base/declare",
    "dojo/_base/array",
    "epi",
    "epi/shell/command/_Command",
    "epi-cms/contentediting/command/_LegacyDialogCommandBase",
    "epi/shell/command/_ClipboardCommandMixin",
    "epi/shell/command/_SelectionCommandMixin",
    "epi/dependency",
    "dijit/Dialog",
    "epi-cms/asset/view-model/HierarchicalListViewModel",
    "epi/routes"
], function (
    dojo,
    topic,
    Iframe,
    declare,
    array,
    epi,
    _Command,
    _LegacyDialogCommandBase,
    _ClipboardCommandMixin,
    _SelectionCommandMixin,
    dependency,
    Dialog,
    HierarchicalListViewModel,
    routes) {

    return declare([_Command, _ClipboardCommandMixin, _SelectionCommandMixin], {
        parent:this,
        // summary:
        //      A command that starts the create new content process when executed.
        //
        // tags:
        //      public

        // label: [readonly] String
        //		The action text of the command to be used in visual elements.
        label: "Crops",

        // iconClass: [readonly] String
        //		The icon class of the command to be used in visual elements.
        iconClass: "epi-iconDuplicatePage",

        // contentStructureStore
        //      Using to refresh contentLink
        contentStructureStore: null,

        postscript: function () {
            this.inherited(arguments);
        },

        _execute: function () {
            var target = this._getSingleSelectionData();
            topic.publish("/epi/shell/context/request", { uri: target.uri }, {
                sender: null,
                forceReload: this.forceReload,
                forceContextChange: this.forceContextChange,
                viewType: null,
                viewName: "cropView"
            });
        },

        _onModelChange: function () {
            var selection = this.selection.data;
            // Only enable the command if there is one selected item and
            // the item is a  digi image
            if (selection && selection.length === 1) {
                var available = selection.every(function (item) {
                    return item.data.capabilities.isDigizuiteEditable && item.data.capabilities.isDigizuiteImage;
                }.bind(this));

                this.set("isAvailable", available);
                this.set("canExecute", available);
               
                return;
            }

            this.set("isAvailable", false);
            this.set("canExecute", false);
        }
    });
});