define([
    "dojo/_base/declare",
    "digizuite/component/MultiSelectList",
    "dojo/text!./SingleSelectList.html"
], function (
    declare,
    MultiSelectList,
    template
    ) {

    return  declare([MultiSelectList], {
            templateString: template,
            options: null,
            label: "Filter",
            multiple: false,
            baseClass: "digi-multi-select-list",
            
            _onApplyFilter: function() {
                var value = this.select.get("value");

                if(!Array.isArray(value)) {
                    this.dropDown.set("label", this.select.getOptions(value).label);
                } else if(value.length === 1) {
                    this.dropDown.set("label", this.select.getOptions(value[0].toString()).label);
                } else if (value.length > 1) {
                    this.dropDown.set("label", this.label + " +" + value.length);
                } else {
                    this.dropDown.set("label", this.label);
                }

                this.set("value", value);
                this.dropDown.closeDropDown();
            }
            
        });

    });